<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: thread_function_extension_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_a969b683060659f05db598aa6ff40bd8.html">threads</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">thread_function_extension_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2007  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_THREAD_FUNCTIOn_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_THREAD_FUNCTIOn_ABSTRACT_ </span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;threads_kernel_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;{</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">class </span>thread_function </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> F&gt;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        thread_function (</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;            F funct</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        );</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> F, <span class="keyword">typename</span> T1&gt;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        thread_function (</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            F funct,</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            T1 arg1</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        );</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> F, <span class="keyword">typename</span> T1, <span class="keyword">typename</span> T2&gt;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        thread_function (</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            F funct,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            T1 arg1,</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            T2 arg2</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        );</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> F, <span class="keyword">typename</span> T1, <span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        thread_function (</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            F funct,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            T1 arg1,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            T2 arg2,</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            T3 arg3</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        );</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> F, <span class="keyword">typename</span> T1, <span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3, <span class="keyword">typename</span> T4&gt;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        thread_function (</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            F funct,</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            T1 arg1,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            T2 arg2,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            T3 arg3,</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            T4 arg4</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        );</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        ~thread_function (</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        );</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordtype">bool</span> is_alive (</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keywordtype">void</span> wait (</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="comment">// restricted functions</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        thread_function(thread_function&amp;);        <span class="comment">// copy constructor</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        thread_function&amp; operator=(thread_function&amp;);    <span class="comment">// assignment operator</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    };</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;}</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160; </div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="preprocessor">#endif // DLIB_THREAD_FUNCTIOn_ABSTRACT_</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
